#include <stdio.h>
#include <stdlib.h>

char *encode( const char *nick, const char *msg )
{
static	char buff[1024];
	char local_nick[30];
	char *p;
	int check1;
	int check2;
	
	strcpy( buff, msg );
	strcpy( local_nick, nick );
	check1=0;
	check2=1;

	for ( p=local_nick; p[0]; p++ )
	{
		check1 += p[0];
		check2 = (check2 * p[0]) % 256;
	}
	
	for ( p=buff; *p; p++ )
	{
		p[0]++;
		check1 += p[0];
		check2 = (check2 * p[0]) % 256;
	}

	check1 = (check1%26) + 'a';
	check2 = (check2%26) + 'a';

	p[0] = check1;
	p[1] = check2;
	p[2] = 0;
	return buff;
}

int *is_encoded( const char *nick, const char *msg )
{
	int check1;
	int check2;
	const char *p;

	if ( strlen(msg)<2 ) return 0;

	check1=0;
	check2=1;

	for ( p=nick; p[0]; p++ )
	{
		check1 += p[0];
		check2 = (check2 * p[0]) % 256;
	}
	
	for ( p=msg; p[2]; p++ )
	{
		check1 += p[0];
		check2 = (check2 * p[0]) % 256;
	}

	check1 = (check1%26) + 'a';
	check2 = (check2%26) + 'a';

	if ( ((char)check1)!=p[0] || ((char)check2)!=p[1] ) return 0;
		
	return 1;
}

char *decode( const char *nick, const char *msg )
{
static	char buff[1024];
	int i;

	if ( strlen(msg)<2 )
	{
		buff[0]=0;
		return buff;
	}
	
	for ( i=0; msg[i+2]; i++ )
		buff[i]=msg[i]-1;
	buff[i]=0;
	return buff;
}



